unit ChipFormUnit;
//==============================================================================
// }bv`bvtH[
//------------------------------------------------------------------------------

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ToolWin, ComCtrls, ExtCtrls, StdCtrls, ActnList,
  ExtDlgs;

const
  IMAGE_PATH: String = 'graphic\'; // `bv摜pX
  CHIP_SIZE: Integer = 16; // }bv`bvTCY
  ZOOM: Integer = 2; //}bv`bvg嗦

type
  TChipForm = class(TForm)
    ChipFormImageList: TImageList;
    ChipFormToolBar: TToolBar;
    ChipFormStatusBar: TStatusBar;
    ChipFormPaintBox: TPaintBox;
    VerticalScrollBar: TScrollBar;
    HorizonScrollBar: TScrollBar;
    IconImageList: TImageList;
    ChipFormActionList: TActionList;
    ChipFormOpenPictureDialog: TOpenPictureDialog;
    LoadChipAction: TAction;
    TB_LoadChip: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ViewGridLineAction: TAction;
    TB_ViewGrid: TToolButton;
    ToolButton1: TToolButton;
    ViewBanAction: TAction;
    TB_ViewBan: TToolButton;
    ToolButton4: TToolButton;
    PinAction: TAction;
    TB_Pin: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure LoadChipActionExecute(Sender: TObject);
    procedure ChipFormPaintBoxPaint(Sender: TObject);
    procedure ViewGridLineActionExecute(Sender: TObject);
    procedure HorizonScrollBarChange(Sender: TObject);
    procedure VerticalScrollBarChange(Sender: TObject);
    procedure ViewBanActionExecute(Sender: TObject);
    procedure PinActionExecute(Sender: TObject);
    procedure ChipFormPaintBoxMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ChipFormPaintBoxMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ChipFormPaintBoxMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
		OffX,OffY: Integer;
		MouseDownAtField: Boolean; // }EX{^Ă邩H

		ViewGrid_Flag: Boolean; // ObhC\H
		ViewBan_flag: Boolean; // ʍsݒ\H
		Pin_flag: Boolean; // s[hH

		procedure ScrollBarResize;
		procedure DrawChip;
  public
    { Public 錾 }
		sx,sy,ex,ey:Integer;
		ChipImgName: String;
		Map_Atty : array of Integer; //}bv̂蔻肪ziƂő傫w肷j
		ChipImg: TBitmap;
		BGChipImg: TBitmap;
    ChipX_Size,ChipY_Size : Integer;
		SCsrX,SCsrY,ECsrX,ECsrY: Integer;
		NowSetParts: Integer; //ݑI𒆂̃`bvԍ
		LoadChip_Flag: Boolean; // `bvǂݍ݂Ă邩H
		SelChip: array of array of Integer;

		procedure MapChipInit(FileName:String);
  end;

var
  ChipForm: TChipForm;

implementation

uses
	MainFormUnit;

{$R *.dfm}

//==============================================================================
//tH[ꂽƂ
procedure TChipForm.FormCreate(Sender: TObject);
begin
	ChipFormPaintBox.ControlStyle := ChipFormPaintBox.ControlStyle + [csOpaque];
  //uǂݍ݁v̏tH_svÖʒu
  ChipFormOpenPictureDialog.InitialDir := ExtractFilePath(Application.ExeName)+IMAGE_PATH;
	ChipImg := TBitmap.Create;
	BGChipImg := TBitmap.Create;

end;
//==============================================================================

//==============================================================================
//tH[jƂ
procedure TChipForm.FormDestroy(Sender: TObject);
begin
	BGChipImg.Free;
	ChipImg.Free;
end;
//==============================================================================

//==============================================================================
//tH[TCYꂽƂ(ꂽƂɂs݂)
procedure TChipForm.FormResize(Sender: TObject);
begin
	ScrollBarResize;
end;
//==============================================================================

//==============================================================================
//XN[o[̈ʒu𒲐
procedure TChipForm.ScrollBarResize;
var
	ScrollInfo: TScrollInfo;
begin
	VerticalScrollBar.Height :=
	ChipForm.ClientHeight-ChipFormStatusBar.Height-HorizonScrollBar.Height-ChipFormToolBar.Height-5;
	HorizonScrollBar.Width :=
	ChipForm.ClientWidth-VerticalScrollBar.Width-3;

	if LoadChip_Flag then
	begin
//------------------------------------------------------------------------------
		if HorizonScrollBar.Width >= (ChipImg.Width*ZOOM) then
		begin
			HorizonScrollBar.Max := 0;
			HorizonScrollBar.Enabled := False;
		end
		else
		begin
			HorizonScrollBar.Max := (ChipImg.Width*ZOOM){-HorizonScrollBar.Width};
			HorizonScrollBar.Enabled := True;

			ScrollInfo.cbSize := Sizeof(TScrollInfo);
			ScrollInfo.fMask := SIF_PAGE;  // nPagêݐݒ肷邱Ƃ
			ScrollInfo.nPage := HorizonScrollBar.Width;  // T̔䗦MaxƂ̔䗦
			SetScrollInfo(ChipForm.HorizonScrollBar.Handle, SB_CTL, ScrollInfo, True);
			if HorizonScrollBar.Focused then // XN[o[ɃtH[JXƂ̂
			begin
				HorizonScrollBar.Enabled := False; // xtH[JXO
				HorizonScrollBar.Enabled := True;
				HorizonScrollBar.SetFocus;     // ēxtH[JX𓖂ĂƓ_ŃTCY
			end;
		end;
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
		if VerticalScrollBar.Height >= (ChipImg.Height*ZOOM) then
		begin
			VerticalScrollBar.Max := 0;
			VerticalScrollBar.Enabled := False;
		end
		else
		begin
			VerticalScrollBar.Max := (ChipImg.Height*ZOOM){-VerticalScrollBar.Height};
			VerticalScrollBar.Enabled := True;

			ScrollInfo.cbSize := Sizeof(TScrollInfo);
			ScrollInfo.fMask := SIF_PAGE;  // nPagêݐݒ肷邱Ƃ
			ScrollInfo.nPage := VerticalScrollBar.Height;  // T̔䗦MaxƂ̔䗦
			SetScrollInfo(ChipForm.VerticalScrollBar.Handle, SB_CTL, ScrollInfo, True);
			if VerticalScrollBar.Focused then // XN[o[ɃtH[JXƂ̂
			begin
				VerticalScrollBar.Enabled := False; // xtH[JXO
				VerticalScrollBar.Enabled := True;
				VerticalScrollBar.SetFocus;     // ēxtH[JX𓖂ĂƓ_ŃTCY
			end;
		end;
//------------------------------------------------------------------------------

		ChipFormPaintBox.Width := HorizonScrollBar.Width;
		ChipFormPaintBox.Height := VerticalScrollBar.Height;
		if ChipFormPaintBox.Width > ChipImg.Width*ZOOM then
			ChipFormPaintBox.Width := ChipImg.Width*ZOOM;
		if ChipFormPaintBox.Height > ChipImg.Height*ZOOM then
			ChipFormPaintBox.Height := ChipImg.Height*ZOOM;

		BGChipImg.Width := ChipFormPaintBox.Width;
		BGChipImg.Height := ChipFormPaintBox.Height;

		VerticalScrollBarChange(ChipForm);
		HorizonScrollBarChange(ChipForm);
	end;
end;
//==============================================================================

//==============================================================================
//}bv`bvǂݍ݃ANV
procedure TChipForm.LoadChipActionExecute(Sender: TObject);
var
  Attr_Max: Integer;
begin
  if ChipFormOpenPictureDialog.Execute = true then
  begin
    if FileExists(ChipFormOpenPictureDialog.FileName) then
		begin
			LoadChip_Flag := True;
			MapChipInit(ChipFormOpenPictureDialog.FileName);
      Attr_Max := (ChipX_Size*ChipY_Size);
      SetLength(Map_Atty,Attr_Max);
			SetLength(SelChip,1,1);
      SelChip[0,0] := 0;
			MainForm.MapImgInit(ChipFormOpenPictureDialog.FileName);
		end;
	end;
end;
//==============================================================================

//==============================================================================
//}bv`bv`揉
procedure TChipForm.MapChipInit(FileName:String);
begin
	ChipImgName := FileName;
	ChipImg.LoadFromFile(ChipImgName);
	BGChipImg.Width := ChipImg.Width*ZOOM;
	BGChipImg.Height := ChipImg.Height*ZOOM;
	ChipX_Size := ChipImg.Width div CHIP_SIZE;
	ChipY_Size := ChipImg.Height div CHIP_SIZE;
	ChipFormPaintBox.Visible := True;
	ScrollBarResize;
	ChipFormPaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//yCg{bNX`揈
procedure TChipForm.ChipFormPaintBoxPaint(Sender: TObject);
begin
	if LoadChip_Flag then
	begin
		DrawChip;
	end;
end;
//==============================================================================

//==============================================================================
//}bv`bv`
procedure TChipForm.DrawChip;
var
	i,j,TmpNow: Integer;
begin
 	 	BGChipImg.Canvas.CopyRect(
		Rect(0-OffX,0-OffY,ChipImg.Width*ZOOM-OffX,ChipImg.Height*ZOOM-OffY),
		ChipImg.Canvas,
		Rect(0,0,ChipImg.Width,ChipImg.Height)
		);
//------------------------------------------------------------------------------
//ʍstOṕ~\ or I𒆃`bvg\
		if ViewBan_flag then
		begin
  		for i:=0 to ChipY_Size-1 do
  		begin
	    	for j:=0 to ChipX_Size-1 do
	    	begin
	      	TmpNow := i * ChipX_Size + j;
	      	IconImageList.Draw(
					BGChipImg.Canvas,
					(j*CHIP_SIZE*ZOOM)-OffX+3,
					(i*CHIP_SIZE*ZOOM)-OffY+3,
					Map_Atty[TmpNow]
					);
	    	end;
  		end;
		end
		else
		begin
//------------------------------------------------------------------------------
//IĂ`bvɘgt
			if (SCsrX < ECsrX) then
			begin
				sx:=SCsrX;
				ex:=ECsrX;
			end
			else
			begin
				sx:=ECsrX;
				ex:=SCsrX;
			end;
			if (SCsrY < ECsrY) then
			begin
				sy:=SCsrY;
				ey:=ECsrY;
			end
			else
			begin
				sy:=ECsrY;
				ey:=SCsrY;
			end;
			BGChipImg.Canvas.Brush.Color:=clBlack;
			BGChipImg.Canvas.FrameRect(Rect(
			sx*CHIP_SIZE*ZOOM-OffX,
			sy*CHIP_SIZE*ZOOM-OffY,
			ex*CHIP_SIZE*ZOOM+(CHIP_SIZE*ZOOM)-OffX,
			ey*CHIP_SIZE*ZOOM+(CHIP_SIZE*ZOOM)-OffY
			));

			BGChipImg.Canvas.Brush.Color:=clWhite;
			BGChipImg.Canvas.FrameRect(Rect(
			sx*CHIP_SIZE*ZOOM-OffX+1,
			sy*CHIP_SIZE*ZOOM-OffY+1,
			ex*CHIP_SIZE*ZOOM+(CHIP_SIZE*ZOOM)-OffX-1,
			ey*CHIP_SIZE*ZOOM+(CHIP_SIZE*ZOOM)-OffY-1
			));

			BGChipImg.Canvas.Brush.Color:=clBlack;
			BGChipImg.Canvas.FrameRect(Rect(
			sx*CHIP_SIZE*ZOOM-OffX+2,
			sy*CHIP_SIZE*ZOOM-OffY+2,
			ex*CHIP_SIZE*ZOOM+(CHIP_SIZE*ZOOM)-OffX-2,
			ey*CHIP_SIZE*ZOOM+(CHIP_SIZE*ZOOM)-OffY-2
			));
//------------------------------------------------------------------------------
		end;
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//ObhC`
  if ViewGrid_Flag then
  begin
		for i:=0 to ChipX_Size do
		begin
	    BGChipImg.Canvas.PenPos := Point(i*CHIP_SIZE*ZOOM-OffX,0-OffY);
	    BGChipImg.Canvas.LineTo(i*CHIP_SIZE*ZOOM-OffX,ChipY_Size*CHIP_SIZE*ZOOM-OffY);
		end;
		for i:=0 to ChipY_Size do
		begin
	    BGChipImg.Canvas.PenPos := Point(0-OffX,i*CHIP_SIZE*ZOOM-OffY);
	    BGChipImg.Canvas.LineTo(ChipX_Size*CHIP_SIZE*ZOOM-OffX,i*CHIP_SIZE*ZOOM-OffY);
		end;
	end;
//------------------------------------------------------------------------------
	ChipFormPaintBox.Canvas.Draw(0,0,BGChipImg);
end;
//==============================================================================

//==============================================================================
//ObhC؂ւANV
procedure TChipForm.ViewGridLineActionExecute(Sender: TObject);
begin
	if ViewGrid_Flag then
	begin
    ViewGrid_Flag := False;
    TB_ViewGrid.Down := False;
	end
	else
	begin
    ViewGrid_Flag := True;
    TB_ViewGrid.Down := True;
	end;
	ChipFormPaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//ʍsݒANV
procedure TChipForm.ViewBanActionExecute(Sender: TObject);
begin
	if ViewBan_Flag then
	begin
    ViewBan_Flag := False;
    TB_ViewBan.Down := False;
    ChipFormPaintBox.Cursor := 2;
	end
	else
	begin
    ViewBan_Flag := True;
    TB_ViewBan.Down := True;
    ChipFormPaintBox.Cursor := 0;
	end;
	ChipFormPaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
// sANV
procedure TChipForm.PinActionExecute(Sender: TObject);
begin
 if Pin_flag then
	begin
    Pin_flag := False;
		TB_Pin.Down := False;
		ChipForm.FormStyle := fsNormal;
	end
	else
	begin
    Pin_flag := True;
		TB_Pin.Down := True;
		ChipForm.FormStyle := fsStayOnTop;
	end;
end;
//==============================================================================

//==============================================================================
//XN[o[PositionςƂ
procedure TChipForm.HorizonScrollBarChange(Sender: TObject);
begin
	if HorizonScrollBar.Position <= ((ChipImg.Width*ZOOM)-HorizonScrollBar.Width) then
	begin
		OffX := HorizonScrollBar.Position;
	end
	else
	begin
    HorizonScrollBar.Position := ((ChipImg.Width*ZOOM)-HorizonScrollBar.Width);
		OffX := HorizonScrollBar.Position;
	end;
	ChipFormPaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//XN[o[PositionςƂ
procedure TChipForm.VerticalScrollBarChange(Sender: TObject);
begin
	if VerticalScrollBar.Position <= ((ChipImg.Height*ZOOM)-VerticalScrollBar.Height) then
	begin
		OffY := VerticalScrollBar.Position;
	end
	else
	begin
		VerticalScrollBar.Position := ((ChipImg.Height*ZOOM)-VerticalScrollBar.Height);
		OffY := VerticalScrollBar.Position;
	end;
	ChipFormPaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//PaintBoxŃ}EX{^ꂽƂ
procedure TChipForm.ChipFormPaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  CurX,CurY,NowChip: Integer;
begin
	CurX := (X+OffX) div (CHIP_SIZE*ZOOM);
	CurY := (Y+OffY) div (CHIP_SIZE*ZOOM);
	if ViewBan_Flag then
	begin
		NowChip := CurY * ChipX_Size + CurX;
		if Map_Atty[NowChip] = 0 then
			Map_Atty[NowChip] := 1
		else
			Map_Atty[NowChip] := 0;
	end
	else
	begin
		SCsrX :=CurX;
		SCsrY :=CurY;
		ECsrX := CurX;
		ECsrY := CurY;
		NowSetParts := CurY * ChipX_Size + CurX;
		MouseDownAtField := True;
	end;
	ChipFormPaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//PaintBoxŃ}EXƂ
procedure TChipForm.ChipFormPaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
 MoX,MoY: Integer;
begin
	if MouseDownAtField then
	begin
	MoX := (X+OffX) div (CHIP_SIZE*ZOOM);
	MoY := (Y+OffY) div (CHIP_SIZE*ZOOM);
		if MoX > (ChipX_Size-1) then
		begin
			ECsrX := ChipX_Size-1;
//			MoX := ChipX_Size-1;
		end
		else
		begin
			ECsrX := MoX;
		end;
		if MoY > (ChipY_Size-1) then
		begin
			ECsrY := ChipY_Size-1;
//			MoY := ChipY_Size-1;
		end
		else
		begin
			ECsrY := MoY;
		end;
		ChipFormPaintBox.Invalidate;
	end;
end;
//==============================================================================

//==============================================================================
//PaintBoxŃ}EX{^ꂽƂ
procedure TChipForm.ChipFormPaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  CurX,CurY: Integer;
	i,j,BoxX,BoxY: Integer;
begin
  if not ViewBan_flag then
  begin
		CurX := (X+OffX) div (CHIP_SIZE*ZOOM);
		CurY := (Y+OffY) div (CHIP_SIZE*ZOOM);
		ECsrX := CurX;
		ECsrY := CurY;
		if CurX > (ChipX_Size-1) then
		begin
			ECsrX := ChipX_Size-1;
		end
		else
		begin
			ECsrX := CurX;
		end;

		if CurY > (ChipY_Size-1) then
		begin
			ECsrY := ChipY_Size-1;
		end
		else
		begin
			ECsrY := CurY;
		end;

		if (SCsrX < ECsrX) then
		begin
			sx:=SCsrX;
			ex:=ECsrX;
		end
		else
		begin
			sx:=ECsrX;
			ex:=SCsrX;
		end;

		if (SCsrY < ECsrY) then
		begin
			sy:=SCsrY;
			ey:=ECsrY;
		end
		else
		begin
			sy:=ECsrY;
			ey:=SCsrY;
		end;

		BoxX := ex-sx+1;
		BoxY := ey-sy+1;

//		͈͑I`bvL
		SetLength(SelChip,BoxX,BoxY);
		for i := 0 to BoxY-1 do
		begin
			for j := 0 to BoxX-1 do
			begin
				SelChip[j,i] := (sy+i) * ChipX_Size + (sx+j);
			end;
		end;
	end;
	MouseDownAtField := False;
	ChipFormPaintBox.Invalidate;
//	ChipFormStatusBar.Panels[0].text := 'I : ' + IntToStr(NowSetParts);
end;
//==============================================================================

//==============================================================================
procedure TChipForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	MainForm.ViewChipFormAction.Checked := False;
end;
//==============================================================================

end.
