unit MainFormUnit;
//==============================================================================
// CtH[
//------------------------------------------------------------------------------

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, Menus, ToolWin, ComCtrls, ActnList, ExtCtrls, StdCtrls;

const
  MAP_PATH: String = 'map\'; // }bvf[^̃pX
  CHIP_SIZE: Integer = 16; // }bv`bvTCY
  X_CHIP: Integer = 20; // ʂɕ\}bv`bv
  Y_CHIP: Integer = 15;

type
	BUFSTR = record
  sx:Integer;    //̈E[XW
  sy:Integer;    //̈YW
	end;

type
TMpdHeader = packed Record
	Version : LongWord;	//t@Co[Wʎq
	MapX: Word;					//}bvXTCY
	MapY: Word;					//}bvYTCY
	ChipX: Word;				//`bvXTCY
	ChipY: Word;				//`bvYTCY
end;

type
  TMainForm = class(TForm)
    MainFormImageList: TImageList;
    MainFormMenu: TMainMenu;
    MainFormToolBar: TToolBar;
    MainFormActionList: TActionList;
    MainFormStatusBar: TStatusBar;
    MainFormPaintBox: TPaintBox;
    HorizonScrollBar: TScrollBar;
    VerticalScrollBar: TScrollBar;
    MainFormOpenDialog: TOpenDialog;
    MainFormSaveDialog: TSaveDialog;
    CreateMapFileAction: TAction;
    OpenMapFileAction: TAction;
    SaveMapFileAction: TAction;
    File1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    ExitAppAction: TAction;
    N4: TMenuItem;
    ExitAppAction1: TMenuItem;
    Show1: TMenuItem;
    MM_ViewChipForm: TMenuItem;
    ToolButton1: TToolButton;
    TB_NewMap: TToolButton;
    ViewChipFormAction: TAction;
    TB_OpenMap: TToolButton;
    TB_SaveMap: TToolButton;
    ToolButton5: TToolButton;
    ViewGridLineAction: TAction;
    TB_ViewGrid: TToolButton;
    ToolButton6: TToolButton;
    InZoomAction: TAction;
    OutZoomAction: TAction;
    TB_InZoom: TToolButton;
    TB_OutZoom: TToolButton;
    ToolButton9: TToolButton;
    PenToolAction: TAction;
    PaintToolAction: TAction;
    TB_Pen: TToolButton;
    TB_Paint: TToolButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CreateMapFileActionExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MainFormPaintBoxPaint(Sender: TObject);
    procedure HorizonScrollBarChange(Sender: TObject);
    procedure VerticalScrollBarChange(Sender: TObject);
    procedure ViewChipFormActionExecute(Sender: TObject);
    procedure OpenMapFileActionExecute(Sender: TObject);
    procedure SaveMapFileActionExecute(Sender: TObject);
    procedure ViewGridLineActionExecute(Sender: TObject);
    procedure InZoomActionExecute(Sender: TObject);
    procedure OutZoomActionExecute(Sender: TObject);
    procedure PenToolActionExecute(Sender: TObject);
    procedure PaintToolActionExecute(Sender: TObject);
    procedure MainFormPaintBoxMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure MainFormPaintBoxMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure MainFormPaintBoxMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
		picked_up  : Boolean;
		xpos_d,Ypos_d: Integer;
		ViewGrid_Flag: Boolean; // ObhC\H
		MapX,MapY : Integer;	//}bv̏cTCY(`bvP)
    Map_Data : array of array of Integer; //}bṽf[^ziƂő傫w肷j
		VpX,VpY: Integer;
		currentFileName : String;
		MouseDownAtField: Boolean;
		GmsX,GmsY: Integer;
		Buffer: array of BUFSTR;
		Start_Idx,End_Idx: Integer;
    MAXSIZE,MINX,MINY,MAXX,MAXY: Integer;
		CurOnBox: Boolean;
 		FMouseControl: TControl;
		CurType: Integer;

		procedure ScrollBarResize;
		procedure DrawMap;
		function SetFileName: Boolean;

		procedure scan_line(lx,rx,y,col:Integer);
		procedure dopaint(x,y,paint_color:Integer);
  public
    { Public 錾 }
  	Zoom: Integer;
		MapImage : TBitmap;//}bv\p
		BGMapImage : TBitmap;//`bv\p

		procedure MapImgInit(FileName:String);
  end;

var
  MainForm: TMainForm;

implementation

uses
	SizeEditFormUnit, ChipFormUnit;

{$R *.dfm}

//==============================================================================
//tH[ꂽƂ
procedure TMainForm.FormCreate(Sender: TObject);
begin
//J[\̓ǂݍ
  Screen.Cursors[1] := LoadCursor(HInstance, 'CurPen');
  Screen.Cursors[2] := LoadCursor(HInstance, 'CurDrop');
  Screen.Cursors[3] := LoadCursor(HInstance, 'CurPaint');
	MainFormPaintBox.ControlStyle := MainFormPaintBox.ControlStyle + [csOpaque];
	CurType := 1;
  MainFormPaintBox.Cursor := CurType;

  //uǂݍ݁v̏tH_svÖʒu
  MainFormOpenDialog.InitialDir := ExtractFilePath(Application.ExeName)+MAP_PATH;
  //uǂݍ݁v̏tH_svÖʒu
  MainFormSaveDialog.InitialDir := ExtractFilePath(Application.ExeName)+MAP_PATH;

	MapImage := TBitmap.Create;
	BGMapImage := TBitmap.Create;
	Zoom := 2;
end;
//==============================================================================

//==============================================================================
//tH[jƂ
procedure TMainForm.FormDestroy(Sender: TObject);
begin
	ChipForm.LoadChip_Flag := False;
	BGMapImage.Free;
	MapImage.Free;
end;
//==============================================================================

//==============================================================================
//tH[TCYꂽƂ(ꂽƂɂs݂)
procedure TMainForm.FormResize(Sender: TObject);
begin
	ScrollBarResize;
end;
//==============================================================================

//==============================================================================
//}bvVK쐬ANV
procedure TMainForm.CreateMapFileActionExecute(Sender: TObject);
begin
  if SizeEditForm.ShowModal = mrOK then
  begin
		MapX := StrToIntDef(SIzeEditForm.Edit_X.Text, X_CHIP);
		MapY := StrToIntDef(SizeEditForm.Edit_Y.Text, Y_CHIP);
		if MapX <X_CHIP then
			MapX := X_CHIP;
		if MapY <Y_CHIP then
			MapY := Y_CHIP;
		SetLength(Map_Data,MapX,MapY);
		ChipForm.LoadChipAction.Enabled := True;
		ScrollBarResize;
	end;
end;
//==============================================================================

//==============================================================================
//`bvEBhE\؂ւANV
procedure TMainForm.ViewChipFormActionExecute(Sender: TObject);
begin
  if ChipForm.Visible then
	begin
		ChipForm.Visible := False;
    ViewChipFormAction.Checked := False;
	end
	else
	begin
		ChipForm.Visible := True;
    ViewChipFormAction.Checked := True;
	end;
end;
//==============================================================================

//==============================================================================
//XN[o[̈ʒu𒲐
procedure TMainForm.ScrollBarResize;
var
	ScrollInfo: TScrollInfo;
begin
	VerticalScrollBar.Height :=
	MainForm.ClientHeight-MainFormStatusBar.Height-HorizonScrollBar.Height-MainFormToolBar.Height-5;
	HorizonScrollBar.Width :=
	MainForm.ClientWidth-VerticalScrollBar.Width-3;

	if ChipForm.LoadChip_Flag then
	begin
//------------------------------------------------------------------------------
		if HorizonScrollBar.Width >= (MapX*CHIP_SIZE*Zoom) then
		begin
			HorizonScrollBar.Max := 0;
			HorizonScrollBar.Enabled := False;
		end
		else
		begin
			HorizonScrollBar.Max := (MapX*CHIP_SIZE*Zoom);
			HorizonScrollBar.Enabled := True;

			ScrollInfo.cbSize := Sizeof(TScrollInfo);
			ScrollInfo.fMask := SIF_PAGE;  // nPagêݐݒ肷邱Ƃ
			ScrollInfo.nPage := HorizonScrollBar.Width;  // T̔䗦MaxƂ̔䗦
			SetScrollInfo(MainForm.HorizonScrollBar.Handle, SB_CTL, ScrollInfo, True);
			if HorizonScrollBar.Focused then // XN[o[ɃtH[JXƂ̂
			begin
				HorizonScrollBar.Enabled := False; // xtH[JXO
				HorizonScrollBar.Enabled := True;
				HorizonScrollBar.SetFocus;     // ēxtH[JX𓖂ĂƓ_ŃTCY
		  end;
		end;
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
		if VerticalScrollBar.Height >= (MapY*CHIP_SIZE*Zoom) then
		begin
			VerticalScrollBar.Max := 0;
			VerticalScrollBar.Enabled := False;
		end
		else
		begin
			VerticalScrollBar.Max := (MapY*CHIP_SIZE*Zoom);
			VerticalScrollBar.Enabled := True;

			ScrollInfo.cbSize := Sizeof(TScrollInfo);
			ScrollInfo.fMask := SIF_PAGE;  // nPagêݐݒ肷邱Ƃ
			ScrollInfo.nPage := VerticalScrollBar.Height;  // T̔䗦MaxƂ̔䗦
			SetScrollInfo(MainForm.VerticalScrollBar.Handle, SB_CTL, ScrollInfo, True);
			if VerticalScrollBar.Focused then // XN[o[ɃtH[JXƂ̂
			begin
				VerticalScrollBar.Enabled := False; // xtH[JXO
				VerticalScrollBar.Enabled := True;
				VerticalScrollBar.SetFocus;     // ēxtH[JX𓖂ĂƓ_ŃTCY
			end;
		end;
//------------------------------------------------------------------------------
		MainFormPaintBox.Width := HorizonScrollBar.Width;
		MainFormPaintBox.Height := VerticalScrollBar.Height;

		if MainFormPaintBox.Width > MapX*CHIP_SIZE*Zoom then
	    MainFormPaintBox.Width := MapX*CHIP_SIZE*Zoom;
		if MainFormPaintBox.Height > MapY*CHIP_SIZE*Zoom then
	    MainFormPaintBox.Height := MapY*CHIP_SIZE*Zoom;

		BGMapImage.Width := MainFormPaintBox.Width;
		BGMapImage.Height := MainFormPaintBox.Height;

		MapImage.Width := MainFormPaintBox.Width;
		MapImage.Height := MainFormPaintBox.Height;

		VerticalScrollBarChange(MainForm);
		HorizonScrollBarChange(MainForm);
	end;
end;
//==============================================================================

//==============================================================================
//}bv`揉
procedure TMainForm.MapImgInit(FileName:String);
begin
  BGMapImage.LoadFromFile(FileName);
	MapImage.Width := HorizonScrollBar.Width;
	MapImage.Height := VerticalScrollBar.Height;

	MainFormPaintBox.Width := HorizonScrollBar.Width;
	MainFormPaintBox.Height := VerticalScrollBar.Height;

	MainFormPaintBox.Visible := True;
	ScrollBarResize;
	MainFormPaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//PaintBox`揈
procedure TMainForm.MainFormPaintBoxPaint(Sender: TObject);
begin
	if ChipForm.LoadChip_Flag then
	begin
		DrawMap;
	end;
end;
//==============================================================================

//==============================================================================
//}bv`
procedure TMainForm.DrawMap;
var
  i,j: Integer;
  ChipData: Integer;  //e`bṽf[^
	SCX,SCY: Integer; //I`bv̈ʒu
  VmapX,VmapY: Integer;
	CpX,CpY: Integer;		//`bvPʂ̓]_
  OfX,OfY: Integer;		//hbgPʂ̓]_
	CmCX,CmCY: Integer;
	BoxX,BoxY:Integer;
begin
	if ChipForm.LoadChip_Flag then
	begin
		VmapX:= (MainFormPaintBox.Width div (CHIP_SIZE*Zoom))+1;
		VmapY:= (MainFormPaintBox.Height div (CHIP_SIZE*Zoom))+1;
		CpX := (VpX div (CHIP_SIZE*Zoom));	//`bvP
		OfX := (VpX mod (CHIP_SIZE*Zoom)); //hbgP
		CpY := (VpY div (CHIP_SIZE*Zoom));
		OfY := (VpY mod (CHIP_SIZE*Zoom));
//------------------------------------------------------------------------------
//[vŔz񂩂oāAobNobt@ɓ]
	  for i := 0 to VmapY do
	  begin
	    for j := 0 to VmapX do
	    begin
				if ((j+CpX) <= (MapX-1)) and ((i+CpY) <= (MapY-1)) then
				begin
					ChipData := Map_Data[j+CpX,i+CpY];
					SCY := ChipData div ChipForm.ChipX_Size;
					SCX := ChipData mod ChipForm.ChipX_Size;
					MapImage.Canvas.CopyRect(
					Rect(
					(j*CHIP_SIZE*Zoom)-OfX,
					(i*CHIP_SIZE*Zoom)-OfY,
					(j*CHIP_SIZE*Zoom)-OfX+(CHIP_SIZE*Zoom),
					(i*CHIP_SIZE*Zoom)-OfY+(CHIP_SIZE*Zoom)
					),
					BGMapImage.Canvas,
					Rect(SCX*CHIP_SIZE,SCY*CHIP_SIZE,(SCX*CHIP_SIZE)+CHIP_SIZE,(SCY*CHIP_SIZE)+CHIP_SIZE)
					);
				end;
			end;
		end;
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//ObhC`
		if ViewGrid_Flag then
		begin
			for i:=0 to VmapX do
			begin
				MapImage.Canvas.PenPos := Point(i*CHIP_SIZE*Zoom-OfX,0-OfY);
				MapImage.Canvas.LineTo(i*CHIP_SIZE*Zoom-OfX,MapY*CHIP_SIZE*Zoom-OfY);
			end;
			for i:=0 to VmapY do
			begin
				MapImage.Canvas.PenPos := Point(0-OfX,i*CHIP_SIZE*Zoom-OfY);
				MapImage.Canvas.LineTo(MapX*CHIP_SIZE*Zoom-OfX,i*CHIP_SIZE*Zoom-OfY);
			end;
		end;
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//`bvJ[\
		if CurOnBox then
		begin
			CmCX := (GmsX-CpX)*CHIP_SIZE*ZOOM-OfX;
			CmCY := (GmsY-CpY)*CHIP_SIZE*ZOOM-OfY;

			BoxX := ChipForm.ex-ChipForm.sx+1;
			BoxY := ChipForm.ey-ChipForm.sy+1;

			MapImage.Canvas.Pen.Color:=clBlack;
			MapImage.Canvas.Polyline([
			Point(CmCX,CmCY),
			Point(CmCX,CmCY+(BoxY*CHIP_SIZE*ZOOM)-1),
			Point(CmCX+(BoxX*CHIP_SIZE*ZOOM)-1,CmCY+(BoxY*CHIP_SIZE*ZOOM)-1),
			Point(CmCX+(BoxX*CHIP_SIZE*ZOOM)-1,CmCY),
			Point(CmCX,CmCY)
			]);

			MapImage.Canvas.Pen.Color:=clWhite;
			MapImage.Canvas.Polyline([
			Point(CmCX+1,CmCY+1),
			Point(CmCX+1,CmCY+(BoxY*CHIP_SIZE*ZOOM)-2),
			Point(CmCX+(BoxX*CHIP_SIZE*ZOOM)-2,CmCY+(BoxY*CHIP_SIZE*ZOOM)-2),
			Point(CmCX+(BoxX*CHIP_SIZE*ZOOM)-2,CmCY+1),
			Point(CmCX+1,CmCY+1)
			]);

			MapImage.Canvas.Pen.Color:=clBlack;
			MapImage.Canvas.Polyline([
			Point(CmCX+2,CmCY+2),
			Point(CmCX+2,CmCY+(BoxY*CHIP_SIZE*ZOOM)-3),
			Point(CmCX+(BoxX*CHIP_SIZE*ZOOM)-3,CmCY+(BoxY*CHIP_SIZE*ZOOM)-3),
			Point(CmCX+(BoxX*CHIP_SIZE*ZOOM)-3,CmCY+2),
			Point(CmCX+2,CmCY+2)
			]);
		end;
//------------------------------------------------------------------------------
		MainFormPaintBox.Canvas.Draw(0,0,MapImage);
	end;
end;
//==============================================================================

//==============================================================================
//XN[o[PositionςƂ
procedure TMainForm.HorizonScrollBarChange(Sender: TObject);
begin
	if HorizonScrollBar.Position <= ((MapX*CHIP_SIZE*Zoom)-HorizonScrollBar.Width) then
	begin
		VpX := HorizonScrollBar.Position;
	end
	else
	begin
    HorizonScrollBar.Position := ((MapX*CHIP_SIZE*Zoom)-HorizonScrollBar.Width);
		VpX := HorizonScrollBar.Position;
	end;
	MainFormPaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//XN[o[PositionςƂ
procedure TMainForm.VerticalScrollBarChange(Sender: TObject);
begin
	if VerticalScrollBar.Position <= ((MapY*CHIP_SIZE*Zoom)-VerticalScrollBar.Height) then
	begin
		VpY := VerticalScrollBar.Position;
	end
	else
	begin
		VerticalScrollBar.Position := ((MapY*CHIP_SIZE*Zoom)-VerticalScrollBar.Height);
		VpY := VerticalScrollBar.Position;
	end;
	MainFormPaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//}bvt@CJ
procedure TMainForm.OpenMapFileActionExecute(Sender: TObject);
var
	i,j : Integer;
	f: TFileStream;
	attrda : array of Byte;
	attrmax: Integer;
	tmpStr: Byte;
	tmpname: String;
	mapda : array of array of Integer;
  chipfn:String;

  MpdHead:TMpdHeader;
begin
  with MainFormOpenDialog do
  begin
    if Execute = true then
		begin
      f:= TFileStream.Create(FileName, fmOpenRead);
      try
				f.ReadBuffer(MpdHead, sizeof(TMpdHeader));
    		if MpdHead.version <> $3144504D then begin
					MessageDlg('t@C`Ⴄ߁AJ܂',mtWarning	,[mbOK],0);
        	Exit;
    		end;
				SetLength(mapda,MpdHead.MapX,MpdHead.MapY);
				attrmax := (MpdHead.ChipX*MpdHead.ChipY);
				SetLength(attrda,attrmax);
				for i:=0 to attrmax-1 do
				begin
					f.ReadBuffer(attrda[i], sizeof(Byte));
				end;

				for i:=0 to 255 do
				begin
					f.ReadBuffer(tmpStr, sizeof(Byte));
					if tmpStr = 0 then Break;
					tmpname := tmpname + chr(tmpStr);
				end;
				for i:=0 to MpdHead.MapY-1 do
				begin
					for j:=0 to MpdHead.MapX-1 do
			 		begin
						f.ReadBuffer(mapda[j,i], sizeof(Word));
					end;
				end;
				SetLength(Map_Data,MpdHead.MapX,MpdHead.MapY);
        MapX:=MpdHead.MapX;
        MapY:=MpdHead.MapY;

				for i:=0 to MpdHead.MapY-1 do
				begin
					for j:=0 to MpdHead.MapX-1 do
			 		begin
						Map_Data[j,i] := mapda[j,i];
					end;
				end;
				ChipForm.LoadChipAction.Enabled := True;
				chipfn := ExtractFilePath(Application.ExeName)+'graphic\'+tmpname;
//------------------------------------------------------------------------------
// }bv`bvǂݍ
				ChipForm.LoadChip_Flag := True;
				ChipForm.MapChipInit(chipfn);
				SetLength(ChipForm.Map_Atty,attrmax);
					for j:=0 to attrmax-1 do
			 		begin
						ChipForm.Map_Atty[j] := attrda[j];
					end;
				MapImgInit(chipfn);
//------------------------------------------------------------------------------
			finally
  			f.Free;
			end;
		end;
  end;
	ScrollBarResize;
end;
//==============================================================================

//==============================================================================
//}bvt@Cۑ
procedure TMainForm.SaveMapFileActionExecute(Sender: TObject);
var
  f: TFileStream;
	i,j,Cfn : Integer;
 	P: PChar;
	tmpChipFileName: String;
	attrda : Byte;
	attrmax: Integer;
	mapdar : Word;

  MpdHead:TMpdHeader;
begin
  MpdHead.version := $3144504D;
	MpdHead.MapX := MapX;
	MpdHead.MapY := MapY;
	MpdHead.ChipX := ChipForm.ChipX_Size;
	MpdHead.ChipY := ChipForm.ChipY_Size;
	attrmax := (MpdHead.ChipX*MpdHead.ChipY)-1;
	tmpChipFileName := ExtractFileName(ChipForm.ChipImgName);
	Cfn := Length(tmpChipFileName);
	P:= PChar(tmpChipFileName);

	if SetFileName = false then Exit;

  f := TFileStream.Create(currentFileName, fmCreate or fmOpenWrite);
	try
  	f.WriteBuffer(MpdHead, sizeof(TMpdHeader));
		for i:=0 to attrmax do
		begin
			attrda := ChipForm.Map_Atty[i];
			f.WriteBuffer(attrda, sizeof(attrda));
		end;
		for i:=0 to Cfn do
		begin
			f.WriteBuffer(P[i], 1);
		end;

		for i:=0 to MpdHead.MapY-1 do
		begin
			for j:=0 to MpdHead.MapX-1 do
			begin
				mapdar := Map_Data[j,i];
				f.WriteBuffer(mapdar, sizeof(mapdar));
			end;
		end;

	finally
  	f.Free;
	end;
showmessage('');
end;
//==============================================================================

//==============================================================================
// t@C`FbNA
function TMainForm.SetFileName: Boolean;
var
  ret : Word;//t@C㏑mFptO
begin
  with MainFormSaveDialog do begin
    if Execute = true then begin
      if FileExists(FileName) then begin
        ret := MessageDlg('̃t@C͂łɑ݂Ă܂B㏑܂H',
                      mtConfirmation, [mbYes, mbNo, mbCancel], 0);
        if (ret = mrNo) or (ret = mrCancel) then
				begin
          Result := false;
          Exit;
        end;
      end;
      if AnsiPos('.mpd', FileName) = 0 then // '.mpd'  FileName ɂ邩ׂ
        FileName := FileName + '.mpd';
      currentFileName := FileName;
      Result := true
    end
    else
      Result := false;
	end;
end;
//==============================================================================

//==============================================================================
//ObhC؂ւANV
procedure TMainForm.ViewGridLineActionExecute(Sender: TObject);
begin
  if ViewGrid_Flag then
	begin
    ViewGrid_Flag:= False;
    TB_ViewGrid.Down := False;
	end
	else
	begin
    ViewGrid_Flag:= True;
    TB_ViewGrid.Down := True;
	end;
	MainFormPaintBox.Invalidate;
end;
//==============================================================================

//==============================================================================
//Y[CANV
procedure TMainForm.InZoomActionExecute(Sender: TObject);
begin
	if not TB_InZoom.Down then
	begin
		TB_InZoom.Down := True;
		TB_OUtZoom.Down := False;
		ZOOM := 2;
		ScrollBarResize;
		MainFormPaintBox.Invalidate;
	end;
end;
//==============================================================================

//==============================================================================
//Y[AEgANV
procedure TMainForm.OutZoomActionExecute(Sender: TObject);
begin
	if not TB_OUtZoom.Down then
	begin
		TB_OUtZoom.Down := True;
		TB_InZoom.Down := False;
		ZOOM := 1;
		ScrollBarResize;
		MainFormPaintBox.Invalidate;
	end;
end;
//==============================================================================

//==============================================================================
//y{^
procedure TMainForm.PenToolActionExecute(Sender: TObject);
begin
	if not TB_Pen.Down then
	begin
    TB_Paint.Down := False;
    TB_Pen.Down := True;

		CurType := 1;
		SetCursor(Screen.Cursors[CurType]);
		MainFormPaintBox.Cursor := CurType;
	end;
end;
//==============================================================================

//==============================================================================
//yL{^
procedure TMainForm.PaintToolActionExecute(Sender: TObject);
begin
	if not TB_Paint.Down then
	begin
    TB_Pen.Down := False;
    TB_Paint.Down := True;

		CurType := 3;
		SetCursor(Screen.Cursors[CurType]);
		MainFormPaintBox.Cursor := CurType;
	end;
end;
//==============================================================================

//==============================================================================
//PaintBoxŃ}EX{^ꂽƂ
procedure TMainForm.MainFormPaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
	CurX,CurY,pper: Integer;
	BoxX,BoxY: Integer;
	i,j:Integer;
begin
	if ChipForm.LoadChip_Flag then
	begin
		MouseDownAtField := True;
		CurX := (VpX+X) div (CHIP_SIZE*ZOOM);
		CurY := (VpY+Y) div (CHIP_SIZE*ZOOM);
		if (Button = mbLeft) then //{^NbN
		begin
			if TB_Pen.Down then
			begin
//------------------------------------------------------------------------------
//y[h
				BoxX := ChipForm.ex-ChipForm.sx;
				BoxY := ChipForm.ey-ChipForm.sy;
				for i := 0 to BoxY do
				begin
					for j := 0 to BoxX do
					begin
						if (CurX+j < MapX) and (CurY+i < MapY) then
						begin
							Map_Data[CurX+j,CurY+i] := ChipForm.SelChip[j,i];
						end;
					end;
				end;
				MainFormPaintBox.Invalidate;
//------------------------------------------------------------------------------
			end
			else
			begin
//------------------------------------------------------------------------------
//yL[h
				pper := Map_Data[CurX,CurY];
				if pper <> ChipForm.NowSetParts then
				begin
					dopaint(CurX,CurY,ChipForm.NowSetParts);
				end;
				MainFormPaintBox.Invalidate;
//------------------------------------------------------------------------------
			end;
		end
		else if Button = mbRight then // X|Cg
		begin
			SetCursor(Screen.Cursors[2]);
			ChipForm.NowSetParts := Map_Data[CurX,CurY];

			ChipForm.sx:=ChipForm.NowSetParts mod ChipForm.ChipX_Size;
			ChipForm.sy:=ChipForm.NowSetParts div ChipForm.ChipX_Size;
			ChipForm.ex:=ChipForm.sx;
			ChipForm.ey:=ChipForm.sy;
			ChipForm.SCsrX:=ChipForm.sx;
			ChipForm.SCsrY:=ChipForm.sy;
			ChipForm.ECsrX:=ChipForm.sx;
			ChipForm.ECsrY:=ChipForm.sy;
			SetLength(ChipForm.SelChip,1,1);
			ChipForm.SelChip[0,0] := Map_Data[CurX,CurY];

			ChipForm.ChipFormPaintBox.Invalidate;
			picked_up := true;  // MouseMove ł͉EĂ邩Ă邩ׂȂ
		end;
    xpos_d := CurX; // MouseMove œꏊŉx`ʂ̂h
		ypos_d := CurY;
	end;
end;
//==============================================================================

//==============================================================================
//PaintBoxŃ}EXƂ
procedure TMainForm.MainFormPaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
	CurX,CurY: Integer;
	BoxX,BoxY: Integer;
	i,j:Integer;
begin
	if ChipForm.LoadChip_Flag then
	begin
		CurX := (VpX+X) div (CHIP_SIZE*ZOOM);
		CurY := (VpY+Y) div (CHIP_SIZE*ZOOM);
		GmsX := CurX;
		GmsY := CurY;
		if picked_up then
		begin
			SetCursor(Screen.Cursors[2]);
			MainFormPaintBox.Invalidate;
			Exit;
		end;
		if ((CurX <> xpos_d) or (CurY <> ypos_d)) and
		((CurX < MapX) and (CurY < MapY)) and
		((CurX >= 0) and (CurY >= 0)) then
		begin
			if (mouseDownAtField) and (TB_Pen.Down) then
			begin
//------------------------------------------------------------------------------
				BoxX := ChipForm.ex-ChipForm.sx;
				BoxY := ChipForm.ey-ChipForm.sy;
				for i := 0 to BoxY do
				begin
					for j := 0 to BoxX do
					begin
						if (CurX+j < MapX) and (CurY+i < MapY) then
						begin
							Map_Data[CurX+j,CurY+i] := ChipForm.SelChip[j,i];
						end;
					end;
				end;
//------------------------------------------------------------------------------
			end;
			MainFormPaintBox.Invalidate;
		end;
		xpos_d := CurX; // MouseMove œꏊŉx`ʂ̂h
		ypos_d := CurY;
//		StatusBar.Panels[0].Text := '(' + IntToStr(CurX) + '/' + IntToStr(CurY) + ')';
	end;
end;
//==============================================================================

//==============================================================================
//PaintBoxŃ}EX{^ꂽƂ
procedure TMainForm.MainFormPaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
	if ChipForm.LoadChip_Flag then
	begin
		SetCursor(Screen.Cursors[CurType]);
		MouseDownAtField := False;
		picked_up :=false;
	end;
end;
//==============================================================================

//==============================================================================
//hԂXLC
procedure TMainForm.scan_line(lx,rx,y,col:Integer);
begin
	while (lx <= rx) do
	begin
		//̈F΂
		for lx:=lx to rx-1 do
		begin
			if Map_Data[lx,y] = col then Break;
		end;
		if Map_Data[lx,y] <> col then Break;
		//̈F΂
		for lx:=lx to rx do
		begin
			if Map_Data[lx,y] <> col then Break;
		end;
		Buffer[End_Idx].sx := lx-1;
		Buffer[End_Idx].sy := y;
    Inc(End_Idx);
		if (End_Idx = MAXSIZE) then
			End_Idx := End_Idx;
	end;
end;
//==============================================================================

//==============================================================================
//hԂC
// http://www2.starcat.ne.jp/~fussy/algo/algo3-1.htm RR̂𒼂
procedure TMainForm.dopaint(x,y,paint_color:Integer);
var
	lx,rx,uy,dy,col,i:Integer;
begin
	SetLength(Buffer, MapX*MapY);	//obt@̃TCYݒ
	Start_Idx := 0;
	End_Idx := 1;
  Buffer[Start_Idx].sx := x;
  Buffer[Start_Idx].sy := y;
  col := Map_Data[x,y];
	MAXSIZE := MapY;
	MINX := 0;
	MINY := 0;
	MAXX := MapX-1;
	MAXY := MapY-1;

	repeat
		lx := Buffer[Start_Idx].sx;
		rx := Buffer[Start_Idx].sx;
		uy := Buffer[Start_Idx].sy;
		dy := Buffer[Start_Idx].sy;
    Inc(Start_Idx);
    if (Start_Idx = MAXSIZE) then
      Start_Idx := Start_Idx;

		//ς̃V[hȂ疳
		if ( Map_Data[lx,uy] = paint_color) then
			Continue;

		//E̋ET
		while ( rx < MAXX ) do
		begin
			if ( Map_Data[rx+1,uy] <> col ) then Break;
			rx := rx+1;
		end;

		//̋ET
		while ( lx > MINX ) do
		begin
			if ( Map_Data[lx - 1,uy] <> col ) then Break;
			lx := lx-1;
		end;

		//lx-rx̐`
		for i:=lx to rx do
		begin
			Map_Data[i,uy] := paint_color;
		end;
		//^̃XLC𑖍
		uy := uy-1;
		if ( uy >= MINY ) then
			scan_line(lx,rx,uy,col);

		//^̃XLC𑖍
		dy := dy+1;
		if ( dy <= MAXY ) then
			scan_line(lx,rx,dy,col);

	until (Start_Idx = End_Idx);
end;
//==============================================================================

//==============================================================================
procedure TMainForm.Timer1Timer(Sender: TObject);
var
	P1: TPoint;
	Control1: TControl;
begin
	if ChipForm.LoadChip_Flag then
	begin
		GetCursorPos(P1);
		Control1 := FindDragTarget(P1, True);
		if FMouseControl <> Control1 then
		begin
		// Rg[}EXł
			if FMouseControl = MainFormPaintBox then
			begin
				CurOnBox := False;
				SetCursor(Screen.Cursors[0]);
				MainFormPaintBox.Cursor := crDefault;
				picked_up :=false;
				MainFormPaintBox.Invalidate;
			end;

			FMouseControl := Control1;
    // Rg[Ƀ}EXƂ
			if FMouseControl = MainFormPaintBox then
			begin
				CurOnBox := True;
				SetCursor(Screen.Cursors[CurType]);
				MainFormPaintBox.Cursor := CurType;
				MainFormPaintBox.Invalidate;
			end;
		end;
	end;
end;
//==============================================================================

end.
